VERSION 5.00
Begin VB.UserControl Clock 
   BackColor       =   &H00C00000&
   BackStyle       =   0  'Transparent
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ClipBehavior    =   0  'None
   HasDC           =   0   'False
   HitBehavior     =   0  'None
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Windowless      =   -1  'True
   Begin VB.Timer Tim 
      Interval        =   100
      Left            =   2640
      Top             =   1260
   End
End
Attribute VB_Name = "Clock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'---- Donnes prives
Private rH As Single
Private rV As Single
Private r As Single
Private ratio As Single
Private Const pi As Single = 3.14159

Private s As Integer
Private m As Integer
Private h As Integer

'---- Dclaration des vnements
Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."

'---- Timer
Private Sub Tim_Timer()
    ' L'heure
    Dim s1 As Integer: s1 = Second(Now)
    Dim m1 As Integer: m1 = Minute(Now)
    Dim h1 As Integer: h1 = Hour(Now)
    
    ' Changement de minute
    If s1 < s Then
        Refresh
    End If

    ' Affiche secondes
    If s <> s1 Then
        AfficheCercle r - 4, vbRed, s1, 60
        s = s1
    End If
    
    ' Affiche minutes
    If m <> m1 Then
        AfficheCercle r - 8, vbMagenta, m1, 60
        m = m1
    End If
    
    ' Affiche heures
    If h <> h1 Then
        AfficheCercle r - 12, vbBlue, h1 Mod 12, 12
        h = h1
    End If
End Sub

'---- Affiche un cercle
Private Sub AfficheCercle(ByVal Rayon As Integer, ByVal Couleur As Long, ByVal Position As Integer, ByVal Divisions As Integer)
    Dim a1 As Single
    Dim a2 As Single
    a1 = 2 * pi - (2 * pi / Divisions) * Position + pi / 2 + 0.00001
    a2 = pi / 2
    If a1 > 2 * pi Then
        a1 = a1 - 2 * pi
    End If
    If Position > 0 Then
        Circle (0, 0), Rayon, Couleur, a1, a2, ratio
    End If

End Sub

'---- Initialisations
Private Sub UserControl_Initialize()
    ' Passe en pixels
    ScaleMode = vbPixels
    DrawWidth = 2
    
End Sub

'---- Contrle visible
Private Sub UserControl_Show()
    ' Timer
    If Ambient.UserMode = True Then
        Tim.Interval = 500
        Tim.Enabled = True
    Else
        Tim.Enabled = False
    End If
End Sub

'---- Dessin du contrle
Private Sub UserControl_Paint()
    Dim dw As Integer
    dw = DrawWidth
    DrawWidth = 2
    Dim i As Integer
    For i = r - 15 To r - 1
        Circle (0, 0), i, vbYellow, , , ratio
    Next
    DrawWidth = dw
    
    ' Provoque un raffichage complet
    s = -1
    m = 99
    h = 99
    Tim_Timer
End Sub

'---- Changement de taille
Private Sub UserControl_Resize()
    ' Calcule rayons
    rH = ScaleWidth / 2
    rV = ScaleHeight / 2
    r = IIf(rH > rV, rH, rV)
    ' Ratio de l'ellipse
    ratio = rV / rH
    ' Origine au centre
    ScaleLeft = -rH
    ScaleTop = -rV
End Sub

'---- HitTest
Private Sub UserControl_HitTest(X As Single, Y As Single, HitResult As Integer)
    ' Calcule la distance au centre
    Dim d As Single
    d = Sqr(X ^ 2 + Y ^ 2)
    If d < r - 16 Then
        'HitResult = vbHitResultTransparent
        HitResult = vbHitResultOutside
    ElseIf d > r Then
        HitResult = vbHitResultOutside
    Else
        HitResult = vbHitResultHit
    End If
End Sub

'---- Evnements
Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

'---- Souris
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub
