VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Connect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "Modification de l'interface"
Option Explicit

' Implmente le modle d'extensibilit
Implements IDTExtensibility

' Instance courante
Public VBInstance As VBide.VBE

' Traitement des vnements des boutons
Public WithEvents evtButton As CommandBarEvents
Attribute evtButton.VB_VarHelpID = -1
Public WithEvents evtButtonCheck As CommandBarEvents
Attribute evtButtonCheck.VB_VarHelpID = -1
Public WithEvents evtButtonLeft As CommandBarEvents
Attribute evtButtonLeft.VB_VarHelpID = -1
Public WithEvents evtButtonCenter As CommandBarEvents
Attribute evtButtonCenter.VB_VarHelpID = -1
Public WithEvents evtButtonRight As CommandBarEvents
Attribute evtButtonRight.VB_VarHelpID = -1
Public WithEvents evtDropdown As CommandBarEvents
Attribute evtDropdown.VB_VarHelpID = -1
Public WithEvents evtCombobox As CommandBarEvents
Attribute evtCombobox.VB_VarHelpID = -1
Public WithEvents evtPopup As CommandBarEvents
Attribute evtPopup.VB_VarHelpID = -1
Public WithEvents evtPopupButton1 As CommandBarEvents
Attribute evtPopupButton1.VB_VarHelpID = -1
Public WithEvents evtPopupButton2 As CommandBarEvents
Attribute evtPopupButton2.VB_VarHelpID = -1
Public WithEvents evtPopupButton3 As CommandBarEvents
Attribute evtPopupButton3.VB_VarHelpID = -1

' Alignement courant
Private fAlign As ALG
Private Enum ALG
    Left
    Center
    Right
End Enum

'---- Ajoute le complment
Private Sub IDTExtensibility_OnConnection(ByVal VBInst As Object, ByVal ConnectMode As vbext_ConnectMode, ByVal AddInInst As VBide.AddIn, custom() As Variant)
    ' Sauve l'instance courante
    Set VBInstance = VBInst
    
    ' Cre la barre d'outils
    Dim cb As CommandBar
    Set cb = AddCommandBar()
    
    ' Ajoute les boutons
    AddButtons cb
    
    ' Initialise
    fAlign = Left
End Sub

'---- Retire le complment
Private Sub IDTExtensibility_OnDisconnection(ByVal RemoveMode As vbext_DisconnectMode, custom() As Variant)
    ' Supprime la barre d'outils
    VBInstance.CommandBars("Test").Delete
End Sub

Private Sub IDTExtensibility_OnStartupComplete(custom() As Variant)
'
End Sub

Private Sub IDTExtensibility_OnAddInsUpdate(custom() As Variant)
'
End Sub

'---- Ajout d'une barre d'outils
Private Function AddCommandBar() As CommandBar
    ' Cre la barre d'outils
    Dim cb As CommandBar
    Set cb = VBInstance.CommandBars.Add("Test")
    ' La rend visible
    cb.Visible = True
    ' Retourne
    Set AddCommandBar = cb
End Function

'---- Ajout des boutons
Private Sub AddButtons(cb As CommandBar)
    Dim ctrl As CommandBarControl
    
    '---- Ajoute un bouton isol
    Set ctrl = cb.Controls.Add(msoControlButton)
    ' Modifie le texte
    ctrl.Caption = LoadResString(100)
    ' et l'icne
    Clipboard.SetData LoadResPicture(1000, vbResBitmap)
    ctrl.PasteFace
    ' Indique le gestionnaire d'vnements
    Set evtButton = VBInstance.Events.CommandBarEvents(ctrl)
    
    '---- Ajoute un groupe de boutons
    Set ctrl = cb.Controls.Add(msoControlButton)
    ' Modifie le texte
    ctrl.Caption = frmMain.iml.ListImages("Left").Tag
    ' et l'icne
    Clipboard.SetData frmMain.iml.ListImages("Left").Picture
    ctrl.PasteFace
    ' Indique Dbut du groupe
    ctrl.BeginGroup = True
    ' Indique le gestionnaire d'vnements
    Set evtButtonLeft = VBInstance.Events.CommandBarEvents(ctrl)

    Set ctrl = cb.Controls.Add(msoControlButton)
    ' Modifie le texte
    ctrl.Caption = frmMain.iml.ListImages("Center").Tag
    ' et l'icne
    Clipboard.SetData frmMain.iml.ListImages("Center").Picture
    ctrl.PasteFace
    ' Indique le gestionnaire d'vnements
    Set evtButtonCenter = VBInstance.Events.CommandBarEvents(ctrl)

    Set ctrl = cb.Controls.Add(msoControlButton)
    ' Modifie le texte
    ctrl.Caption = frmMain.iml.ListImages("Right").Tag
    ' et l'icne
    Clipboard.SetData frmMain.iml.ListImages("Right").Picture
    ctrl.PasteFace
    ' Indique le gestionnaire d'vnements
    Set evtButtonRight = VBInstance.Events.CommandBarEvents(ctrl)
    
    '---- Ajoute un bouton check
    Set ctrl = cb.Controls.Add(msoControlButton)
    ' Modifie le texte
    ctrl.Caption = LoadResString(100)
    ' et l'icne
    Clipboard.SetData LoadResPicture(1000, vbResBitmap)
    ctrl.PasteFace
    ' Indique Dbut du groupe
    ctrl.BeginGroup = True
    ' Indique le gestionnaire d'vnements
    Set evtButtonCheck = VBInstance.Events.CommandBarEvents(ctrl)

    '---- Ajoute une combobox en lecture seule
    Set ctrl = cb.Controls.Add(msoControlDropdown)
    ctrl.Caption = "Dropdown"
    ctrl.AddItem "Andr"
    ctrl.AddItem "Bernard"
    ctrl.AddItem "Claude"
    ' Indique le gestionnaire d'vnements
    Set evtDropdown = VBInstance.Events.CommandBarEvents(ctrl)
    
    '---- Ajoute une combobox avec dition
    Set ctrl = cb.Controls.Add(msoControlComboBox)
    ctrl.Caption = "Combobox"
    ctrl.AddItem "Andr"
    ctrl.AddItem "Bernard"
    ctrl.AddItem "Claude"
    ' Indique le gestionnaire d'vnements
    Set evtCombobox = VBInstance.Events.CommandBarEvents(ctrl)
    
    '---- Ajoute un popup
    Set ctrl = cb.Controls.Add(msoControlPopup)
    ctrl.Caption = "Popup"
    ' Ajoute les boutons sous le popup
    Dim c As CommandBarButton
    Dim i
    For i = 1 To 3
        Set c = ctrl.Controls.Add(msoControlButton)
        c.Caption = frmMain.iml.ListImages(i).Tag
        Clipboard.SetData frmMain.iml.ListImages(i).Picture
        c.PasteFace
        ' Indique le gestionnaire d'vnements
        Select Case i
            Case 1
                Set evtPopupButton1 = VBInstance.Events.CommandBarEvents(c)
            Case 2
                Set evtPopupButton2 = VBInstance.Events.CommandBarEvents(c)
            Case 3
                Set evtPopupButton3 = VBInstance.Events.CommandBarEvents(c)
        End Select
    Next
    ' Ajoute une combobox (pourquoi pas...)
    Dim cc As CommandBarComboBox
    Set cc = ctrl.Controls.Add(msoControlDropdown)
    cc.Caption = "Dropdown"
    cc.AddItem "Andr"
    cc.AddItem "Bernard"
    cc.AddItem "Claude"
    ' Indique le gestionnaire d'vnements
    Set evtPopup = VBInstance.Events.CommandBarEvents(ctrl)
End Sub

'---- Click sur un bouton de la barre de commande
Private Sub evtButton_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Debug.Print "Hi from " & CommandBarControl.Caption
End Sub

Private Sub evtButtonCheck_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Debug.Print "Hi from " & CommandBarControl.Caption
    If CommandBarControl.State = msoButtonDown Then CommandBarControl.State = msoButtonUp Else CommandBarControl.State = msoButtonDown
End Sub

Private Sub evtButtonLeft_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    fAlign = Left
    UpdateAlignButtons CommandBarControl.Parent
End Sub

Private Sub evtButtonCenter_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    fAlign = Center
    UpdateAlignButtons CommandBarControl.Parent
End Sub

Private Sub evtButtonRight_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    fAlign = Right
    UpdateAlignButtons CommandBarControl.Parent
End Sub

Private Sub evtCombobox_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Debug.Print "Hi from " & CommandBarControl.Caption & " - " & CommandBarControl.Text
End Sub

Private Sub evtDropdown_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Debug.Print "Hi from " & CommandBarControl.Caption & " - " & CommandBarControl.Text
End Sub

Private Sub evtPopup_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Debug.Print "Hi from " & CommandBarControl.Caption
End Sub

Private Sub evtPopupButton1_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Debug.Print "Hi from " & CommandBarControl.Caption
End Sub

Private Sub evtPopupButton2_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Debug.Print "Hi from " & CommandBarControl.Caption
End Sub

Private Sub evtPopupButton3_Click(ByVal CommandBarControl As Object, handled As Boolean, CancelDefault As Boolean)
    Debug.Print "Hi from " & CommandBarControl.Caption
End Sub

'---- Mise  jour du groupe Align
Private Sub UpdateAlignButtons(cmd As CommandBar)
    cmd.Controls("Gauche").State = IIf(fAlign = Left, msoButtonDown, msoButtonUp)
    cmd.Controls("Centr").State = IIf(fAlign = Center, msoButtonDown, msoButtonUp)
    cmd.Controls("Droite").State = IIf(fAlign = Right, msoButtonDown, msoButtonUp)
End Sub
